@echo off
:: 关闭命令提示符的输出，使得在执行时不显示任何命令

setlocal enabledelayedexpansion
:: 开启延迟环境变量扩展。这允许在for循环中设置和使用变量

:: 获取当前脚本所在的目录，并存储在CURRENT_DIR变量中
set CURRENT_DIR=%~dp0
:: %~dp0是一个特殊变量，它返回当前脚本的完整路径

:: 定义备份目录的路径，这是我们要从中恢复文件的目录
set BACKUP_DIR=%CURRENT_DIR%backup
:: 将当前目录与"backup"子目录字符串合并来创建备份目录的完整路径

:: 定义应用程序的名称
set EXE_NAME=KincoServo3.exe
:: 这是你要启动的应用程序的名称

:: 检查备份目录是否存在
if exist "%BACKUP_DIR%" (
    :: 如果备份目录存在，则遍历备份目录中的每个文件
    for %%F in ("%BACKUP_DIR%\*.*") do (
        :: 获取当前文件的大小
        set size_src=%%~zF
        
        :: 获取当前目录中相同名称文件的大小
        for %%D in ("%CURRENT_DIR%%%~nxF") do set size_dest=%%~zD

        :: 比较备份文件与当前目录中的文件大小
        if not "!size_src!"=="!size_dest!" (
            :: 如果文件大小不同，则从备份目录复制文件到当前目录
            xcopy /y /s "%%F" "%CURRENT_DIR%%%~nxF" >nul 2>&1
        )
    )
)

:: 添加短暂的延时，确保之前的应用程序实例已经完全关闭
timeout /t 1 /nobreak >nul

:: 启动应用程序
start "" "%CURRENT_DIR%%EXE_NAME%"

endlocal
:: 结束延迟环境变量扩展，返回正常的命令行环境
